=== debian/changelog ===
fdk-aac-free (2.0.2-3~ubuntu4) noble; urgency=medium

  * autopkgtest: Don't try comparing hashes since they aren't consistent
    among architectures

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 09 Feb 2024 08:13:42 -0500

fdk-aac-free (2.0.2-3~ubuntu3) noble; urgency=medium

  * Cherry-pick 2 patches to add some basic regression tests
  * Add patch to skip testing the HE profiles since they are not included here
  * Add autopkgtest to run the regression test

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 08 Feb 2024 23:26:59 -0500

fdk-aac-free (2.0.2-3~ubuntu2) noble; urgency=medium

  * Clean up minor Lintian warnings
  * Drop unused sparc defines from add_more_arch patch and forward upstream

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 05 Dec 2023 08:57:54 -0500

fdk-aac-free (2.0.2-3~ubuntu1) mantic; urgency=medium

  * Upload directly to Ubuntu since the Debian NEW processing is slow.
    See Ubuntu bug 1977614 & Debian 981285 for more background

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 22 Aug 2023 09:20:45 -0400

fdk-aac-free (2.0.2-3) UNRELEASED; urgency=medium

  * Team upload
  * Package Fedora's stripped version of fdk-aac using the same source
    package name Fedora uses. This avoids various concerns with the unstripped
    version. The stripped version should be sufficient for Debian's needs and
    this allows this library to be accepted into main instead of non-free.
    (Closes: #981285)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 19 Jul 2023 15:50:48 -0400

fdk-aac (2.0.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * debian/control: Bump Standards-Version
  * debian/: Bump debhelper compat to 13
  * debian/copyright: Update copyright years

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 24 Sep 2021 00:20:49 +0200

fdk-aac (2.0.1-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.

  [ Fabian Greffrath ]
  * New upstream version 2.0.1 (Closes: #915386).
  * Bump SONAME to libfdk-aac2.
  * Refresh patches.
  * Enable all hardening flags.
  * Bump Standards-Version to 4.5.0
  * Install the static library archive in the libfdk-aac-dev package
    (Closes: #865710).

 -- Fabian Greffrath <fabian@debian.org>  Wed, 18 Mar 2020 20:53:14 +0100

fdk-aac (0.1.6-1) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org
  * d/changelog: Remove trailing whitespaces
  * d/control: Remove trailing whitespaces

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * d/rules: Remove trailing whitespaces

  [ Sebastian Ramacher ]
  * New upstream release.
  * debhelper/: Bump debhelper compat level to 11.
  * debian/control:
    - Bump Standards-Version.
    - Remove old Pre-Depends.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 20 May 2018 13:47:37 +0200

fdk-aac (0.1.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/patches: Removed patches obsoleted by new upstream release.
  * debian/copyright: Update copyright years.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 18 Jun 2017 12:10:55 +0200

fdk-aac (0.1.4-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 28 Sep 2016 20:18:29 +0200

fdk-aac (0.1.4-1) experimental; urgency=medium

  [ Alessio Treglia ]
  * New upstream release. (Closes: #784908)
  * debian/patches:
    - Refresh add_more_arch.
    - Drop missing_ppc_files. (Closes: #771924)

  [ Sebastian Ramacher ]
  * debian/patches/gcc6_c++98: Upstream patch to fix FTBFS with GCC 6 (Closes:
    #836933)
  * Bump SONAME: libfdk-aac0 -> libfdk-aac1.
  * debian/{control,rules}: Switch to automatic dbgsym packages.
  * debian/control: Bump Standards-Version.

  [ Daniel Knezevic ]
  * debian/rules: Remove -march=mips32r2 on mips* platforms. (Closes: #838364)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 24 Sep 2016 17:18:45 +0200

fdk-aac (0.1.3+20140816-2) unstable; urgency=medium

  * Fix FTBFS for real this time:
  * Added missing powerpc ASM files.
  * Add missing #defines for sparc and s390x.
  * Add correct CPPFLAGS for mips.

 -- Romain Beauxis <toots@rastageeks.org>  Sun, 17 Aug 2014 09:37:14 -0500

fdk-aac (0.1.3+20140816-1) unstable; urgency=medium

  * Update to latest upstream.
  * Fix FTBFS on mips, sparc and s390x.
  * Bump standards version to 3.9.5

 -- Romain Beauxis <toots@rastageeks.org>  Mon, 11 Aug 2014 19:42:04 -0500

fdk-aac (0.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update debian/copyright.

 -- Alessio Treglia <alessio@debian.org>  Fri, 25 Jul 2014 11:18:31 +0100

fdk-aac (0.1.2-1) unstable; urgency=low

  * Team upload.
  * New upstream release.
  * Add watch file. Thanks to Bart Martens for the great work.

 -- Alessio Treglia <alessio@debian.org>  Mon, 14 Oct 2013 23:52:35 +0100

fdk-aac (0.1.1+20130514-3) unstable; urgency=low

  * Team upload.
  * Include PDF documentation (Closes: #721532)

 -- Alessio Treglia <alessio@debian.org>  Mon, 02 Sep 2013 09:38:37 +0100

fdk-aac (0.1.1+20130514-2) unstable; urgency=low

  * Explain autobuild.

 -- Romain Beauxis <toots@rastageeks.org>  Tue, 11 Jun 2013 19:06:07 -0500

fdk-aac (0.1.1+20130514-1) unstable; urgency=low

  * Initial upload.
  Closes: #694257

 -- Romain Beauxis <toots@rastageeks.org>  Tue, 14 May 2013 06:13:57 -0500
