=== debian/control ===
Source: fdk-aac-free
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Romain Beauxis <toots@rastageeks.org>
Homepage: https://gitlab.freedesktop.org/wtaymans/fdk-aac-stripped
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13)
Vcs-Git: https://salsa.debian.org/multimedia-team/fdk-aac.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/fdk-aac
Rules-Requires-Root: no

Package: libfdk-aac2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Fraunhofer FDK AAC Codec Library - runtime files
 The FDK AAC Codec Library For Android contains an encoder implementation
 of the Advanced Audio Coding (AAC) audio codec.
 .
 This package contains the files needed to run a program compiled using
 The Fraunhofer FDK AAC Codec Library.

Package: libfdk-aac-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfdk-aac2 (= ${binary:Version}),
 ${misc:Depends}
Description: Fraunhofer FDK AAC Codec Library - development files
 The FDK AAC Codec Library For Android contains an encoder implementation
 of the Advanced Audio Coding (AAC) audio codec.
 .
 This package contains the files needed to compile and statically link
 against the Fraunhofer FDK AAC Codec Library.

Package: aac-enc
Architecture: any
Depends:
  ${shlibs:Depends},
  ${misc:Depends}
Section: sound
Description: Fraunhofer FDK AAC Codec Library - frontend binary
 The FDK AAC Codec Library For Android contains an encoder implementation
 of the Advanced Audio Coding (AAC) audio codec.
 .
 This package contains a frontend binary capable of encoding WAVE files
 using the Fraunhofer FDK AAC Codec Library.
