=== debian/tests/control ===
Tests: upstream
Restrictions: allow-stderr needs-internet superficial
Depends: aac-enc, build-essential, debhelper, ca-certificates, curl, ffmpeg
