=== debian/watch ===
version=4
https://gitlab.freedesktop.org/wtaymans/fdk-aac-stripped/-/tags?sort=version_desc \
 .*/fdk-aac-stripped-v?(2.[\d.]+)@ARCHIVE_EXT@
